/*
    Dirichlet Process Mixture of Hidden Markov Models: Accompanying Software
    Copyright (C) <2009>  <Kristin P. Lennox and David B. Dahl>

    Contact: lennox@stat.tamu.edu

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

 */

package HMMDP.BaseDistributions;

import java.util.Random;


public interface DistributionArray<PARAMETER> {
    
  public abstract double logDensity(PARAMETER[] x) throws Exception;
  public abstract double logDensityKernel(PARAMETER[] x) throws Exception;
  public abstract double logNormalizingConstant();
  public abstract PARAMETER[] sample(Random random);
  public abstract int getLength();

}
